"""
Functions governing the motion of objects in the Universe

**Binaries**

.. autosummary::

    keplerorbit.get_orbit
    keplerorbit.get_barycentric_orbit
    
**Hierarchical system**

.. autosummary::

    keplerorbit.get_hierarchical_orbit
    keplerorbit.get_hierarchical_orbits
    keplerorbit.get_barycentric_hierarchical_orbit

**Utility functions**

.. autosummary::
    
    keplerorbit.apparent_coordinates
    keplerorbit.mean_anomaly_to_time
    keplerorbit.calculate_phase
    keplerorbit.calculate_critical_phases
    keplerorbit.eclipse_separation
    keplerorbit.per0_from_eclipse_separation
    keplerorbit.third_law
    keplerorbit.calculate_asini
    keplerorbit.calculate_mass_function
    keplerorbit.get_incl_from_mass_function
    keplerorbit.get_incl_from_RV
    keplerorbit.calculate_mass
    keplerorbit.calculate_total_radius_from_eclipse_duration
    
**Phoebe interface**

.. autosummary::
    
    keplerorbit.get_binary_orbit
    
"""